#include <assert.h>

extern "C" {
int printf (__const__ char *format, ...);
}

void TRACE(const char *fmt ...);

#define	DevOpenDC(hab, lType, pszToken, lCount, pdopData, hdcComp) \
	DebugDevOpenDC(__FILE__, __LINE__, hab, lType, pszToken, lCount, pdopData, hdcComp)
#define	DevQueryCaps(hdc, lStart, lCount, alArray) \
	DebugDevQueryCaps(__FILE__, __LINE__, hdc, lStart, lCount, alArray)
#define	DosAllocSharedMem(pBaseAddress, pszName, ulObjectSize, ulAllocationFlags) \
	DebugDosAllocSharedMem(__FILE__, __LINE__, pBaseAddress, pszName, ulObjectSize, ulAllocationFlags)
#define	DosFreeMem(pBaseAddress) \
	DebugDosFreeMem(__FILE__, __LINE__, pBaseAddress)
#define	DosGetInfoBlocks(ptib, ppib) \
	DebugDosGetInfoBlocks(__FILE__, __LINE__, ptib, ppib)
#define	DosGiveSharedMem(pBaseAddress, idProcessId, ulAttributeFlags) \
	DebugDosGiveSharedMem(__FILE__, __LINE__, pBaseAddress, idProcessId, ulAttributeFlags)
#define	DosOpenQueue(ppid, phq, pszName) \
	DebugDosOpenQueue(__FILE__, __LINE__, ppid, phq, pszName)
#define	DosWriteQueue(hq, ulRequest, ulDataLength, pData, ulPriority) \
	DebugDosWriteQueue(__FILE__, __LINE__, hq, ulRequest, ulDataLength, pData, ulPriority)
#define	GpiBeginPath(hps, lPath) \
	DebugGpiBeginPath(__FILE__, __LINE__, hps, lPath)
#define	GpiBitBlt(hpsTarget, hpsSource, lCount, aptlPoints, lRop, flOptions) \
	DebugGpiBitBlt(__FILE__, __LINE__, hpsTarget, hpsSource, lCount, aptlPoints, lRop, flOptions)
#define	GpiBox(hps, lControl, pptlPoint, lHRound, lVRound) \
	DebugGpiBox(__FILE__, __LINE__, hps, lControl, pptlPoint, lHRound, lVRound)
#define	GpiCharStringAt(hps, pptlPoint, lCount,  pchString) \
	DebugGpiCharStringAt(__FILE__, __LINE__, hps, pptlPoint, lCount,  pchString)
#define	GpiCreateBitmap(hps, pbmpNew, flOptions, pbInitData, pbmiInfoTable) \
	DebugGpiCreateBitmap(__FILE__, __LINE__, hps, pbmpNew, flOptions, pbInitData, pbmiInfoTable)
#define	GpiCreateLogColorTable(hps, flOptions, lFormat, lStart, lCount, alTable) \
	DebugGpiCreateLogColorTable(__FILE__, __LINE__, hps, flOptions, lFormat, lStart, lCount, alTable)
#define	GpiCreatePS(hab, hdc, psizlSize, flOptions) \
	DebugGpiCreatePS(__FILE__, __LINE__, hab, hdc, psizlSize, flOptions)
#define	GpiDeleteBitmap(hbm) \
	DebugGpiDeleteBitmap(__FILE__, __LINE__, hbm)
#define	GpiEndPath(hps) \
	DebugGpiEndPath(__FILE__, __LINE__, hps)
#define	GpiFillPath(hps, lPath, lOptions) \
	DebugGpiFillPath(__FILE__, __LINE__, hps, lPath, lOptions)
#define	GpiFullArc(hps, lControl, fxMultiplier) \
	DebugGpiFullArc(__FILE__, __LINE__, hps, lControl, fxMultiplier)
#define	GpiLine(hps, pptlEndPoint) \
	DebugGpiLine(__FILE__, __LINE__, hps, pptlEndPoint)
#define	GpiMove(hps, pptlPoint) \
	DebugGpiMove(__FILE__, __LINE__, hps, pptlPoint)
#define	GpiPartialArc(hps, pptlCenter, fxMultiplier, fxStartAngle, fxSweepAngle) \
	DebugGpiPartialArc(__FILE__, __LINE__, hps, pptlCenter, fxMultiplier, fxStartAngle, fxSweepAngle)
#define	GpiPolyLine(hps, lCount, aptlPoints) \
	DebugGpiPolyLine(__FILE__, __LINE__, hps, lCount, aptlPoints)
#define	GpiQueryBackColor(hps) \
	DebugGpiQueryBackColor(__FILE__, __LINE__, hps)
#define	GpiQueryBackMix(hps) \
	DebugGpiQueryBackMix(__FILE__, __LINE__, hps)
#define	GpiQueryCharSet(hps) \
	DebugGpiQueryCharSet(__FILE__, __LINE__, hps)
#define	GpiQueryDevice(hps) \
	DebugGpiQueryDevice(__FILE__, __LINE__, hps)
#define	GpiQueryFontMetrics(hps, lMetricsLength, pfmMetrics) \
	DebugGpiQueryFontMetrics(__FILE__, __LINE__, hps, lMetricsLength, pfmMetrics)
#define	GpiQueryTextBox(hps, lCount1, pchString, lCount2, aptlPoints) \
	DebugGpiQueryTextBox(__FILE__, __LINE__, hps, lCount1, pchString, lCount2, aptlPoints)
#define	GpiSelectPalette(hps, hpal) \
	DebugGpiSelectPalette(__FILE__, __LINE__, hps, hpal)
#define	GpiSetArcParams(hps, parcpArcParams) \
	DebugGpiSetArcParams(__FILE__, __LINE__, hps, parcpArcParams)
#define	GpiSetAttrs(hps, lPrimType, flAttrMask, flDefMask, ppbunAttrs) \
	DebugGpiSetAttrs(__FILE__, __LINE__, hps, lPrimType, flAttrMask, flDefMask, ppbunAttrs)
#define	GpiSetBackColor(hps, lColor) \
	DebugGpiSetBackColor(__FILE__, __LINE__, hps, lColor)
#define	GpiSetBackMix(hps, lMixMode) \
	DebugGpiSetBackMix(__FILE__, __LINE__, hps, lMixMode)
#define	GpiSetBitmap(hps, hbm) \
	DebugGpiSetBitmap(__FILE__, __LINE__, hps, hbm)
#define	GpiSetCharSet(hps, llcid) \
	DebugGpiSetCharSet(__FILE__, __LINE__, hps, llcid)
#define	GpiSetColor(hps, lColor) \
	DebugGpiSetColor(__FILE__, __LINE__, hps, lColor)
#define	GpiSetMix(hps, lMixMode) \
	DebugGpiSetMix(__FILE__, __LINE__, hps, lMixMode)
#define	GpiSetPel(hps, pptlPoint) \
	DebugGpiSetPel(__FILE__, __LINE__, hps, pptlPoint)
#define	PrfCloseProfile(hini) \
	DebugPrfCloseProfile(__FILE__, __LINE__, hini)
#define	PrfOpenProfile(hab, pszFileName) \
	DebugPrfOpenProfile(__FILE__, __LINE__, hab, pszFileName)
#define	PrfQueryProfileData(hini, pszApp, pszKey, pBuffer, pulBufferLength) \
	DebugPrfQueryProfileData(__FILE__, __LINE__, hini, pszApp, pszKey, pBuffer, pulBufferLength)
#define	PrfWriteProfileData(hini, pszApp, pszKey, pData, ulDataLength) \
	DebugPrfWriteProfileData(__FILE__, __LINE__, hini, pszApp, pszKey, pData, ulDataLength)
#define	WinBeginPaint(hwnd, hps, prclPaint) \
	DebugWinBeginPaint(__FILE__, __LINE__, hwnd, hps, prclPaint)
#define	WinCreateMenu(hwndParent, lpmt) \
	DebugWinCreateMenu(__FILE__, __LINE__, hwndParent, lpmt)
#define	WinCreateMsgQueue(hab, cmsg) \
	DebugWinCreateMsgQueue(__FILE__, __LINE__, hab, cmsg)
#define	WinCreateWindow(hwndParent, pszClass, pszName, flStyle, x, y, cx, cy, hwndOwner, hwndInsertBehind, id, pCtlData, pPresParams) \
	DebugWinCreateWindow(__FILE__, __LINE__, hwndParent, pszClass, pszName, flStyle, x, y, cx, cy, hwndOwner, hwndInsertBehind, id, pCtlData, pPresParams)
#define	WinDestroyPointer(hptr) \
	DebugWinDestroyPointer(__FILE__, __LINE__, hptr)
#define	WinDestroyWindow(hwnd) \
	DebugWinDestroyWindow(__FILE__, __LINE__, hwnd)
#define	WinDrawPointer(hps, x, y, hptr, fs) \
	DebugWinDrawPointer(__FILE__, __LINE__, hps, x, y, hptr, fs)
#define	WinEnableWindow(hwnd, fEnable) \
	DebugWinEnableWindow(__FILE__, __LINE__, hwnd, fEnable)
#define	WinEndPaint(hps) \
	DebugWinEndPaint(__FILE__, __LINE__, hps)
#define	WinFillRect(hps, prcl, lColor) \
	DebugWinFillRect(__FILE__, __LINE__, hps, prcl, lColor)
#define	WinGetMsg(hab, pqmsg, hwndFilter, msgFilterFirst, msgFilterLast) \
	DebugWinGetMsg(__FILE__, __LINE__, hab, pqmsg, hwndFilter, msgFilterFirst, msgFilterLast)
#define	WinGetPS(hwnd) \
	DebugWinGetPS(__FILE__, __LINE__, hwnd)
#define	WinInitialize(fsOptions) \
	DebugWinInitialize(__FILE__, __LINE__, fsOptions)
#define	WinInvalidateRect(hwnd, prcl, fIncludeChildren) \
	DebugWinInvalidateRect(__FILE__, __LINE__, hwnd, prcl, fIncludeChildren)
#define	WinInvalidateRegion(hwnd, hrgn, fIncludeChildren) \
	DebugWinInvalidateRegion(__FILE__, __LINE__, hwnd, hrgn, fIncludeChildren)
#define	WinLoadPointer(hwndDesktop, hmod, idres) \
	DebugWinLoadPointer(__FILE__, __LINE__, hwndDesktop, hmod, idres)
#define	WinMapWindowPoints(hwndFrom, hwndTo, prgptl, cwpt) \
	DebugWinMapWindowPoints(__FILE__, __LINE__, hwndFrom, hwndTo, prgptl, cwpt)
#define	WinMessageBox(hwndParent, hwndOwner, pszText, pszCaption, idWindow, flStyle) \
	DebugWinMessageBox(__FILE__, __LINE__, hwndParent, hwndOwner, pszText, pszCaption, idWindow, flStyle)
#define	WinPostMsg(hwnd, msg, mp1, mp2) \
	DebugWinPostMsg(__FILE__, __LINE__, hwnd, msg, mp1, mp2)
#define	WinQueryClassInfo(hab, pszClassName, pClassInfo) \
	DebugWinQueryClassInfo(__FILE__, __LINE__, hab, pszClassName, pClassInfo)
#define	WinQueryPointerPos(hwndDesktop, pptl) \
	DebugWinQueryPointerPos(__FILE__, __LINE__, hwndDesktop, pptl)
#define	WinQueryUpdateRect(hwnd, prcl) \
	DebugWinQueryUpdateRect(__FILE__, __LINE__, hwnd, prcl)
#define	WinQueryWindow(hwnd, cmd) \
	DebugWinQueryWindow(__FILE__, __LINE__, hwnd, cmd)
#define	WinQueryWindowRect(hwnd, prclDest) \
	DebugWinQueryWindowRect(__FILE__, __LINE__, hwnd, prclDest)
#define	WinRealizePalette(hwnd, hps, pcclr) \
	DebugWinRealizePalette(__FILE__, __LINE__, hwnd, hps, pcclr)
#define	WinRegisterClass(hab, pszClassName, pfnWndProc, flStyle, cbWindowData) \
	DebugWinRegisterClass(__FILE__, __LINE__, hab, pszClassName, pfnWndProc, flStyle, cbWindowData)
#define	WinReleasePS(hps) \
	DebugWinReleasePS(__FILE__, __LINE__, hps)
#define	WinScrollWindow(hwnd, dx, dy, prclScroll, prclClip, hrgnUpdate, prclUpdate, rgfsw) \
	DebugWinScrollWindow(__FILE__, __LINE__, hwnd, dx, dy, prclScroll, prclClip, hrgnUpdate, prclUpdate, rgfsw)
#define	WinSetCapture(hwndDesktop, hwnd) \
	DebugWinSetCapture(__FILE__, __LINE__, hwndDesktop, hwnd)
#define	WinSetFocus(hwndDesktop, hwndSetFocus) \
	DebugWinSetFocus(__FILE__, __LINE__, hwndDesktop, hwndSetFocus)
#define	WinSetPointer(hwndDesktop, hptrNew) \
	DebugWinSetPointer(__FILE__, __LINE__, hwndDesktop, hptrNew)
#define	WinSetPointerPos(hwndDesktop, x, y) \
	DebugWinSetPointerPos(__FILE__, __LINE__, hwndDesktop, x, y)
#define	WinSetPresParam(hwnd, id, cbParam, pbParam) \
	DebugWinSetPresParam(__FILE__, __LINE__, hwnd, id, cbParam, pbParam)
#define	WinSetWindowPos(hwnd, hwndInsertBehind, x, y, cx, cy, fl) \
	DebugWinSetWindowPos(__FILE__, __LINE__, hwnd, hwndInsertBehind, x, y, cx, cy, fl)
#define	WinSetWindowText(hwnd, pszText) \
	DebugWinSetWindowText(__FILE__, __LINE__, hwnd, pszText)
#define	WinSetWindowULong(hwnd, index, ul) \
	DebugWinSetWindowULong(__FILE__, __LINE__, hwnd, index, ul)
#define	WinSetWindowPtr(hwnd, index, p) \
	DebugWinSetWindowPtr(__FILE__, __LINE__, hwnd, index, p)
#define	WinShowWindow(hwnd, fShow) \
	DebugWinShowWindow(__FILE__, __LINE__, hwnd, fShow)
#define	WinStartTimer(hab, hwnd, idTimer, dtTimeout) \
	DebugWinStartTimer(__FILE__, __LINE__, hab, hwnd, idTimer, dtTimeout)
#define	WinStopTimer(hab, hwnd, idTimer) \
	DebugWinStopTimer(__FILE__, __LINE__, hab, hwnd, idTimer)
#define	WinTerminate(hab) \
	DebugWinTerminate(__FILE__, __LINE__, hab)
#define	WinUpdateWindow(hwnd) \
	DebugWinUpdateWindow(__FILE__, __LINE__, hwnd)
#define	WinWindowFromID(hwndParent, id) \
	DebugWinWindowFromID(__FILE__, __LINE__, hwndParent, id)
#define	WinQuerySysPointer(hwndDesktop, lId, fCopy) \
	DebugWinQuerySysPointer(__FILE__, __LINE__, hwndDesktop, lId, fCopy)
#define	WinCreateFrameControls(hwndFrame, pfcdata, pszTitle) \
	DebugWinCreateFrameControls(__FILE__, __LINE__, hwndFrame, pfcdata, pszTitle)
#define GpiSetPS(hps, psizlsize, flOptions) \
	DebugGpiSetPS(__FILE__, __LINE__, hps, psizlsize, flOptions)
#define GpiQueryPageViewport(hps, prclViewport) \
	DebugGpiQueryPageViewport(__FILE__, __LINE__, hps, prclViewport)
#define GpiSetPageViewport(hps, prclViewport) \
	DebugGpiSetPageViewport (__FILE__, __LINE__, hps, prclViewport)
#define	GpiQueryBitmapParameters(hbm, pbmpData) \
	DebugGpiQueryBitmapParameters(__FILE__, __LINE__, hbm, pbmpData)
#define	WinFileDlg(hwndP, hwndO, pfild) \
	DebugWinFileDlg (__FILE__, __LINE__, hwndP, hwndO, pfild)
#define	WinQueryPointer(hwndDesktop) \
	DebugWinQueryPointer(__FILE__, __LINE__, hwndDesktop)
#define	GpiSetClipPath(hps, lPath, lOptions) \
	DebugGpiSetClipPath(__FILE__, __LINE__, hps, lPath, lOptions)
#define	GpiSetClipRegion(hps, hrgn, phrgnOld) \
	DebugGpiSetClipRegion(__FILE__, __LINE__, hps, hrgn, phrgnOld)
#define	WinOpenWindowDC(hwnd) \
        DebugWinOpenWindowDC(__FILE__, __LINE__, hwnd)
#define	GpiDestroyPS(hps) \
	DebugGpiDestroyPS(__FILE__, __LINE__, hps)
#define	GpiCreateLogFont(hps, pName, lLcid, pfatAttrs) \
	DebugGpiCreateLogFont(__FILE__, __LINE__, hps, pName, lLcid, pfatAttrs)
#define	GpiSetCharBox(hps, psizfxBox) \
	DebugGpiSetCharBox(__FILE__, __LINE__, hps, psizfxBox)
#define	GpiDeleteSetId(hps, lLcid) \
	DebugGpiDeleteSetId(__FILE__, __LINE__, hps, lLcid)
#define	GpiDrawBits(hps, pBits, pbmiInfoTable, lCount, aptlPoints, lRop, flOptions) \
	DebugGpiDrawBits(__FILE__, __LINE__, hps, pBits, pbmiInfoTable, lCount, aptlPoints, lRop, flOptions)
#define	WinCalcFrameRect(hwndFrame, prcl, fClient) \
	DebugWinCalcFrameRect(__FILE__, __LINE__, hwndFrame, prcl, fClient)
#define	WinProcessDlg(hwndDlg) \
	DebugWinProcessDlg(__FILE__, __LINE__, hwndDlg)
#define	WinDismissDlg(hwndDlg, usResult) \
	DebugWinDismissDlg(__FILE__, __LINE__, hwndDlg, usResult)
#define	GpiQueryRGBColor(hps, flOptions, lColorIndex) \
	DebugGpiQueryRGBColor(__FILE__, __LINE__, hps, flOptions, lColorIndex)
#define	GpiErase(hps) \
	DebugGpiErase(__FILE__, __LINE__, hps)
#define	GpiQueryBitmapInfoHeader(hbm, pbmpData) \
	DebugGpiQueryBitmapInfoHeader(__FILE__, __LINE__, hbm, pbmpData)
#define	WinDestroyAccelTable(haccel) \
	DebugWinDestroyAccelTable(__FILE__, __LINE__, haccel)
#define	WinLoadAccelTable(hab, hmod, idAccelTable) \
	DebugWinLoadAccelTable(__FILE__, __LINE__, hab, hmod, idAccelTable)
#define	WinSetAccelTable(hab, haccel, hwndFrame) \
	DebugWinSetAccelTable(__FILE__, __LINE__, hab, haccel, hwndFrame)
#define	WinLoadMenu(hwndFrame, hmod, idMenu) \
	DebugWinLoadMenu(__FILE__, __LINE__, hwndFrame, hmod, idMenu)
#define	WinQueryWindowPos(hwnd, pswp) \
	DebugWinQueryWindowPos(__FILE__, __LINE__, hwnd, pswp)
#define WinPopupMenu(hwndParent, hwndOwner, hwndMenu, x, y, idItem, fs) \
	DebugWinPopupMenu(__FILE__, __LINE__, hwndParent, hwndOwner, hwndMenu, x, y, idItem, fs)



HDC DebugDevOpenDC(const char *file, int line, HAB hab, LONG lType, PCSZ pszToken, LONG lCount, PDEVOPENDATA pdopData, HDC hdcComp);
BOOL DebugDevQueryCaps(const char *file, int line, HDC hdc, LONG lStart, LONG lCount, PLONG alArray);
ULONG DebugDosAllocSharedMem(const char *file, int line, PPVOID pBaseAddress, PCSZ pszName, ULONG ulObjectSize, ULONG ulAllocationFlags);
ULONG DebugDosFreeMem(const char *file, int line, PVOID pBaseAddress);
ULONG DebugDosGetInfoBlocks(const char *file, int line, PTIB *ptib, PPIB *ppib);
ULONG DebugDosGiveSharedMem(const char *file, int line, CPVOID pBaseAddress, PID idProcessId, ULONG ulAttributeFlags);
ULONG DebugDosOpenQueue(const char *file, int line, PPID ppid, PHQUEUE phq, PCSZ pszName);
ULONG DebugDosWriteQueue(const char *file, int line, HQUEUE hq, ULONG ulRequest, ULONG ulDataLength, PVOID pData, ULONG ulPriority);
BOOL DebugGpiBeginPath(const char *file, int line, HPS hps, LONG lPath);
LONG DebugGpiBitBlt(const char *file, int line, HPS hpsTarget, HPS hpsSource, LONG lCount, __const__ POINTL *aptlPoints, LONG lRop, ULONG flOptions);
LONG DebugGpiBox(const char *file, int line, HPS hps, LONG lControl, __const__ POINTL *pptlPoint, LONG lHRound, LONG lVRound);
LONG DebugGpiCharStringAt(const char *file, int line, HPS hps, __const__ POINTL *pptlPoint, LONG lCount,  PCCH pchString);
HBITMAP DebugGpiCreateBitmap(const char *file, int line, HPS hps, __const__ BITMAPINFOHEADER2 *pbmpNew, ULONG flOptions, __const__ BYTE *pbInitData, __const__ BITMAPINFO2 *pbmiInfoTable);
BOOL DebugGpiCreateLogColorTable(const char *file, int line, HPS hps, ULONG flOptions, LONG lFormat, LONG lStart, LONG lCount, __const__ LONG *alTable);
HPS DebugGpiCreatePS(const char *file, int line, HAB hab, HDC hdc, PSIZEL psizlSize, ULONG flOptions);
BOOL DebugGpiDeleteBitmap(const char *file, int line, HBITMAP hbm);
BOOL DebugGpiEndPath(const char *file, int line, HPS hps);
LONG DebugGpiFillPath(const char *file, int line, HPS hps, LONG lPath, LONG lOptions);
LONG DebugGpiFullArc(const char *file, int line, HPS hps, LONG lControl, FIXED fxMultiplier);
LONG DebugGpiLine(const char *file, int line, HPS hps, __const__ POINTL *pptlEndPoint);
BOOL DebugGpiMove(const char *file, int line, HPS hps, __const__ POINTL *pptlPoint);
LONG DebugGpiPartialArc(const char *file, int line, HPS hps, __const__ POINTL *pptlCenter, FIXED fxMultiplier, FIXED fxStartAngle, FIXED fxSweepAngle);
LONG DebugGpiPolyLine(const char *file, int line, HPS hps, LONG lCount, __const__ POINTL *aptlPoints);
LONG DebugGpiQueryBackColor(const char *file, int line, HPS hps);
LONG DebugGpiQueryBackMix(const char *file, int line, HPS hps);
LONG DebugGpiQueryCharSet(const char *file, int line, HPS hps);
HDC DebugGpiQueryDevice(const char *file, int line, HPS hps);
BOOL DebugGpiQueryFontMetrics(const char *file, int line, HPS hps, LONG lMetricsLength, PFONTMETRICS pfmMetrics);
BOOL DebugGpiQueryTextBox(const char *file, int line, HPS hps, LONG lCount1, PCH pchString, LONG lCount2, PPOINTL aptlPoints);
HPAL DebugGpiSelectPalette(const char *file, int line, HPS hps, HPAL hpal);
BOOL DebugGpiSetArcParams(const char *file, int line, HPS hps, __const__ ARCPARAMS *parcpArcParams);
BOOL DebugGpiSetAttrs(const char *file, int line, HPS hps, LONG lPrimType, ULONG flAttrMask, ULONG flDefMask, __const__ VOID *ppbunAttrs);
BOOL DebugGpiSetBackColor(const char *file, int line, HPS hps, LONG lColor);
BOOL DebugGpiSetBackMix(const char *file, int line, HPS hps, LONG lMixMode);
HBITMAP DebugGpiSetBitmap(const char *file, int line, HPS hps, HBITMAP hbm);
BOOL DebugGpiSetCharSet(const char *file, int line, HPS hps, LONG llcid);
BOOL DebugGpiSetColor(const char *file, int line, HPS hps, LONG lColor);
BOOL DebugGpiSetMix(const char *file, int line, HPS hps, LONG lMixMode);
LONG DebugGpiSetPel(const char *file, int line, HPS hps, __const__ POINTL *pptlPoint);
BOOL DebugPrfCloseProfile(const char *file, int line, HINI hini);
HINI DebugPrfOpenProfile(const char *file, int line, HAB hab, PCSZ pszFileName);
BOOL DebugPrfQueryProfileData(const char *file, int line, HINI hini, PCSZ pszApp, PCSZ pszKey, PVOID pBuffer, PULONG pulBufferLength);
BOOL DebugPrfWriteProfileData(const char *file, int line, HINI hini, PCSZ pszApp, PCSZ pszKey, CPVOID pData, ULONG ulDataLength);
HPS DebugWinBeginPaint(const char *file, int line, HWND hwnd, HPS hps, PRECTL prclPaint);
HWND DebugWinCreateMenu(const char *file, int line, HWND hwndParent, CPVOID lpmt);
HMQ DebugWinCreateMsgQueue(const char *file, int line, HAB hab, LONG cmsg);
HWND DebugWinCreateWindow(const char *file, int line, HWND hwndParent, PCSZ pszClass, PCSZ pszName, ULONG flStyle, LONG x, LONG y, LONG cx, LONG cy, HWND hwndOwner, HWND hwndInsertBehind, ULONG id, PVOID pCtlData, PVOID pPresParams);
BOOL DebugWinDestroyPointer(const char *file, int line, HPOINTER hptr);
BOOL DebugWinDestroyWindow(const char *file, int line, HWND hwnd);
BOOL DebugWinDrawPointer(const char *file, int line, HPS hps, LONG x, LONG y, HPOINTER hptr, ULONG fs);
BOOL DebugWinEnableWindow(const char *file, int line, HWND hwnd, BOOL fEnable);
BOOL DebugWinEndPaint(const char *file, int line, HPS hps);
BOOL DebugWinFillRect(const char *file, int line, HPS hps, __const__ RECTL *prcl, LONG lColor);
BOOL DebugWinGetMsg(const char *file, int line, HAB hab, PQMSG pqmsg, HWND hwndFilter, ULONG msgFilterFirst, ULONG msgFilterLast);
HPS DebugWinGetPS(const char *file, int line, HWND hwnd);
HAB DebugWinInitialize(const char *file, int line, ULONG fsOptions);
BOOL DebugWinInvalidateRect(const char *file, int line, HWND hwnd, __const__ RECTL *prcl, BOOL fIncludeChildren);
BOOL DebugWinInvalidateRegion(const char *file, int line, HWND hwnd, HRGN hrgn, BOOL fIncludeChildren);
HPOINTER DebugWinLoadPointer(const char *file, int line, HWND hwndDesktop, HMODULE hmod, ULONG idres);
BOOL DebugWinMapWindowPoints(const char *file, int line, HWND hwndFrom, HWND hwndTo, PPOINTL prgptl, LONG cwpt);
ULONG DebugWinMessageBox(const char *file, int line, HWND hwndParent, HWND hwndOwner, PCSZ pszText, PCSZ pszCaption, ULONG idWindow, ULONG flStyle);
BOOL DebugWinPostMsg(const char *file, int line, HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
BOOL DebugWinPtInRect(const char *file, int line, HAB hab, __const__ RECTL *prcl, __const__ POINTL *pptl);
BOOL DebugWinQueryClassInfo(const char *file, int line, HAB hab, PCSZ pszClassName, PCLASSINFO pClassInfo);
BOOL DebugWinQueryPointerPos(const char *file, int line, HWND hwndDesktop, PPOINTL pptl);
BOOL DebugWinQueryUpdateRect(const char *file, int line, HWND hwnd, PRECTL prcl);
HWND DebugWinQueryWindow(const char *file, int line, HWND hwnd, LONG cmd);
BOOL DebugWinQueryWindowRect(const char *file, int line, HWND hwnd, PRECTL prclDest);
LONG DebugWinRealizePalette(const char *file, int line, HWND hwnd, HPS hps, PULONG pcclr);
BOOL DebugWinRegisterClass(const char *file, int line, HAB hab, PCSZ pszClassName, PFNWP pfnWndProc, ULONG flStyle, ULONG cbWindowData);
BOOL DebugWinReleasePS(const char *file, int line, HPS hps);
LONG DebugWinScrollWindow(const char *file, int line, HWND hwnd, LONG dx, LONG dy, __const__ RECTL *prclScroll, __const__ RECTL *prclClip, HRGN hrgnUpdate, PRECTL prclUpdate, ULONG rgfsw);
BOOL DebugWinSetCapture(const char *file, int line, HWND hwndDesktop, HWND hwnd);
BOOL DebugWinSetFocus(const char *file, int line, HWND hwndDesktop, HWND hwndSetFocus);
BOOL DebugWinSetPointer(const char *file, int line, HWND hwndDesktop, HPOINTER hptrNew);
BOOL DebugWinSetPointerPos(const char *file, int line, HWND hwndDesktop, LONG x, LONG y);
BOOL DebugWinSetPresParam(const char *file, int line, HWND hwnd, ULONG id, ULONG cbParam, PVOID pbParam);
BOOL DebugWinSetWindowPos(const char *file, int line, HWND hwnd, HWND hwndInsertBehind, LONG x, LONG y, LONG cx, LONG cy, ULONG fl);
BOOL DebugWinSetWindowText(const char *file, int line, HWND hwnd, PCSZ pszText);
BOOL DebugWinSetWindowULong(const char *file, int line, HWND hwnd, LONG index, ULONG ul);
BOOL DebugWinSetWindowPtr(const char *file, int line, HWND hwnd, LONG index, PVOID p);
BOOL DebugWinShowWindow(const char *file, int line, HWND hwnd, BOOL fShow);
ULONG DebugWinStartTimer(const char *file, int line, HAB hab, HWND hwnd, ULONG idTimer, ULONG dtTimeout);
BOOL DebugWinStopTimer(const char *file, int line, HAB hab, HWND hwnd, ULONG idTimer);
BOOL DebugWinTerminate(const char *file, int line, HAB hab);
BOOL DebugWinUpdateWindow(const char *file, int line, HWND hwnd);
HWND DebugWinWindowFromID(const char *file, int line, HWND hwndParent, ULONG id);
HPOINTER DebugWinQuerySysPointer(const char *file, int line, HWND hwndDesktop, LONG lId, BOOL fCopy);
BOOL DebugWinCreateFrameControls(const char *file, int line, HWND hwndFrame, PFRAMECDATA pfcdata, PCSZ pszTitle);
BOOL DebugGpiSetPS(const char *file, int line, HPS hps, __const__ SIZEL *psizlsize, ULONG flOptions);
BOOL DebugGpiQueryPageViewport(const char *file, int line, HPS hps, PRECTL prclViewport);
BOOL DebugGpiSetPageViewport(const char *file, int line, HPS hps, __const__ RECTL *prclViewport);
BOOL DebugGpiQueryBitmapParameters (const char *file, int line, HBITMAP hbm, PBITMAPINFOHEADER pbmpData);
HWND DebugWinFileDlg (const char *file, int line, HWND hwndP, HWND hwndO, PFILEDLG pfild);
HPOINTER DebugWinQueryPointer(const char *file, int line, HWND hwndDesktop);
BOOL DebugGpiSetClipPath(const char *file, int line, HPS hps, LONG lPath, LONG lOptions);
LONG DebugGpiSetClipRegion(const char *file, int line, HPS hps, HRGN hrgn, PHRGN phrgnOld);
HDC DebugWinOpenWindowDC(const char *file, int line, HWND hwnd);
BOOL DebugGpiDestroyPS(const char *file, int line, HPS hps);
LONG DebugGpiCreateLogFont(const char *file, int line, HPS hps, __const__ STR8 *pName, LONG lLcid, __const__ FATTRS *pfatAttrs);
BOOL DebugGpiSetCharBox(const char *file, int line, HPS hps, __const__ SIZEF *psizfxBox);
BOOL DebugGpiDeleteSetId(const char *file, int line, HPS hps, LONG lLcid);
LONG DebugGpiDrawBits(const char *file, int line, HPS hps, __const__ VOID *pBits,
		      __const__ BITMAPINFO2 *pbmiInfoTable, LONG lCount,
		      __const__ POINTL *aptlPoints, LONG lRop, ULONG flOptions);
BOOL DebugWinCalcFrameRect(const char *file, int line, HWND hwndFrame, PRECTL prcl, BOOL fClient);
ULONG DebugWinProcessDlg(const char *file, int line, HWND hwndDlg);
BOOL DebugWinDismissDlg(const char *file, int line, HWND hwndDlg, ULONG usResult);
LONG DebugGpiQueryRGBColor(const char *file, int line, HPS hps, ULONG flOptions, LONG lColorIndex);
BOOL DebugGpiErase(const char *file, int line, HPS hps);
BOOL DebugGpiQueryBitmapInfoHeader(const char *file, int line, HBITMAP hbm, PBITMAPINFOHEADER2 pbmpData);
BOOL DebugWinDestroyAccelTable(const char *file, int line, HACCEL haccel);
HACCEL DebugWinLoadAccelTable(const char *file, int line, HAB hab, HMODULE hmod, ULONG idAccelTable);
BOOL DebugWinSetAccelTable(const char *file, int line, HAB hab, HACCEL haccel, HWND hwndFrame);
HWND DebugWinLoadMenu(const char *file, int line, HWND hwndFrame, HMODULE hmod, ULONG idMenu);
BOOL DebugWinQueryWindowPos(const char *file, int line, HWND hwnd, PSWP pswp);
BOOL DebugWinPopupMenu(const char *file, int line, HWND hwndParent, HWND hwndOwner, HWND hwndMenu,
			LONG x, LONG y, LONG idItem, ULONG fs);

char *wxMessageStr(int msg);
void wxTraceEvent(char *rtr, HWND hWnd, ULONG msg, MPARAM mp1, MPARAM mp2, PVOID wnd);


