/*
 * Global Data
 *
 * RCS_ID:      $Id: wb_data.cc,v 1.3 1994/08/14 21:34:01 edz Exp $
 */

/* static const char sccsid[] = "@(#)wb_data.cc	1.2 5/9/94"; */

#ifdef __GNUG__
#pragma implementation
#endif

// For compilers that support precompilation, includes "wx.h".
#include "wx_prec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "common.h"
#include "wx_setup.h"
#include "wx_list.h"
#include "wx_gdi.h"
#endif

#define _MAXPATHLEN 500

// Useful buffer, initialized in wxCommonInit
char *wxBuffer = NULL;

// Windows List
wxList wxTopLevelWindows;

// Message Strings for Internationalization
char **wx_msg_str = (char**)NULL;

// Custom OS version, as optionally placed in wx.ini/.wxrc
// Currently this can be Win95, Windows, Win32s, WinNT.
// For some systems, you can't tell until run-time what services you
// have. See wxGetOsVersion, which uses this string if present.
#ifndef wx_os2
char *wxOsVersion = NULL;
#endif

int wxPageNumber;

// GDI Object Lists
wxBrushList *wxTheBrushList = NULL;
wxPenList   *wxThePenList = NULL;
wxFontList   *wxTheFontList = NULL;
wxGDIList   *wxTheBitmapList = NULL;
//wxGDIList   *wxTheColourList = NULL;

wxColourDatabase *wxTheColourDatabase = NULL;

// Stock objects
wxFont *wxNORMAL_FONT;
wxFont *wxSMALL_FONT;
wxFont *wxITALIC_FONT;
wxFont *wxSWISS_FONT;
wxPen *wxRED_PEN;

wxPen *wxCYAN_PEN;
wxPen *wxGREEN_PEN;
wxPen *wxBLACK_PEN;
wxPen *wxWHITE_PEN;
wxPen *wxTRANSPARENT_PEN;
wxPen *wxBLACK_DASHED_PEN;
wxPen *wxGREY_PEN;
wxPen *wxMEDIUM_GREY_PEN;
wxPen *wxLIGHT_GREY_PEN;

wxBrush *wxBLUE_BRUSH;
wxBrush *wxGREEN_BRUSH;
wxBrush *wxWHITE_BRUSH;
wxBrush *wxBLACK_BRUSH;
wxBrush *wxTRANSPARENT_BRUSH;
wxBrush *wxCYAN_BRUSH;
wxBrush *wxRED_BRUSH;
wxBrush *wxGREY_BRUSH;
wxBrush *wxMEDIUM_GREY_BRUSH;
wxBrush *wxLIGHT_GREY_BRUSH;

wxColour *wxBLACK;
wxColour *wxWHITE;
wxColour *wxRED;
wxColour *wxBLUE;
wxColour *wxGREEN;
wxColour *wxCYAN;
wxColour *wxLIGHT_GREY;

wxCursor *wxSTANDARD_CURSOR = NULL;
wxCursor *wxHOURGLASS_CURSOR = NULL;
wxCursor *wxCROSS_CURSOR = NULL;

// Default window names
Constdata char *wxButtonNameStr = "button";
Constdata char *wxCanvasNameStr = "canvas";
Constdata char *wxCheckBoxNameStr = "check";
Constdata char *wxChoiceNameStr = "choice";
Constdata char *wxDialogNameStr = "dialog";
Constdata char *wxFrameNameStr = "frame";
Constdata char *wxGaugeNameStr = "gauge";
Constdata char *wxGroupBoxNameStr = "groupBox";
Constdata char *wxListBoxNameStr = "listBox";
Constdata char *wxMessageNameStr = "message";
Constdata char *wxMultiTextNameStr = "multitext";
Constdata char *wxPanelNameStr = "panel";
Constdata char *wxRadioBoxNameStr = "radioBox";
Constdata char *wxScrollBarNameStr = "scrollBar";
Constdata char *wxSliderNameStr = "slider";
Constdata char *wxStaticNameStr = "static";
Constdata char *wxTextWindowNameStr = "textWindow";
Constdata char *wxTextNameStr = "text";
Constdata char *wxVirtListBoxNameStr = "virtListBox";
Constdata char *wxButtonBarNameStr = "buttonbar";
Constdata char *wxEnhDialogNameStr = "Shell";
Constdata char *wxToolBarNameStr = "toolbar";
Constdata char *wxStatusLineNameStr = "status_line";
Constdata char *wxEmptyString = "";
Constdata char *wxInternalErrorStr = "wxWindows Internal Error";
Constdata char *wxFatalErrorStr = "wxWindows Fatal Error";
Constdata char *wxGetTextFromUserPromptStr = "Input Text";
Constdata char *wxMessageBoxCaptionStr = "Message";
Constdata char *wxFileSelectorPromptStr = "Select a file";
Constdata char *wxFileSelectorDefaultWildcardStr = "*.*";

